'use strict';

Object.defineProperty(exports, '__esModule', {
  value: true
});
exports['default'] = react2tree;

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactAddonsTestUtils = require('react-addons-test-utils');

var _utils = require('./utils');

function react2tree(app) {
  var name = arguments.length <= 1 || arguments[1] === undefined ? 'tree' : arguments[1];

  var tree = {
    name: name,
    children: []
  };

  if (!(0, _reactAddonsTestUtils.isCompositeComponent)(app)) {
    return tree;
  }

  /*eslint-disable*/
  traverse(app, tree);
  /*eslint-enable*/

  function traverse(c, node) {
    if (!c || (0, _reactAddonsTestUtils.isDOMComponent)(c)) {
      return;
    }

    var newNodeName = typeof c === 'function' ? c.name : c.constructor.name;

    node.children.push({
      name: newNodeName,
      children: []
    });

    var ccc = (0, _reactAddonsTestUtils.getRenderedChildOfCompositeComponent)(c);

    if ((0, _reactAddonsTestUtils.isDOMComponent)(ccc)) {
      _react2['default'].Children.forEach(ccc.props.children, function traverseChildWithNode(child) {
        if (child.type) {
          traverse(child.type, (0, _utils.getNode)(node, newNodeName));
        }
      });
    } else {
      traverse(ccc, (0, _utils.getNode)(node, c.constructor.name));
    }
  }

  return tree;
}

module.exports = exports['default'];